module Bitfinex
  module Wallet
    # Ratelimit: 90 req/min
    # https://docs.bitfinex.com/reference#rest-auth-info-user
    def user_info
      res = request("auth/r/info/user").body
      return JSON.parse(res)
    end

    # Ratelimit: 90 req/min
    # https://docs.bitfinex.com/reference#key-permissions
    def permissions
      res = request("auth/r/permissions").body
      return JSON.parse(res)
    end

    # https://docs.bitfinex.com/reference#rest-auth-withdraw
    def withdraw(wallet, method, amount, address)
      res = request("auth/w/withdraw", {
        wallet: wallet,#'exchange',
        method: method,#'tetheruse',
        amount: amount,#'10',
        address: address#'0x2bf788d017C4DF927787DF2EB1310266d9db6893',
      }).body
      return JSON.parse(res)
    end
    
    # Ratelimit: 45 req/min
    # https://docs.bitfinex.com/reference#rest-auth-movements
    def movements
      res = request("auth/r/movements/hist").body
      return JSON.parse(res)
    end
    
    # Ratelimit: 45 req/min
    # https://docs.bitfinex.com/reference#rest-auth-wallets
    def wallets
      res = request("auth/r/wallets").body
      return JSON.parse(res)
    end

    # 45 req/min
    # https://docs.bitfinex.com/reference#rest-auth-ledgers
    def ledgers(currency)
      res = request("auth/r/ledgers/#{currency}/hist", {
        limit: 2500,
        # category: 28,
      }).body
      return JSON.parse(res)
    end

    # Ratelimit: 45 req/min
    # https://docs.bitfinex.com/reference#rest-auth-wallets-hist
    def wallets_history(currency)
      request("auth/r/wallets/hist", {
        currency: currency,
        end: (Time.now.to_f * 1000).floor,
      }).body
    end

    # Ratelimit: 30 req/min
    # https://docs.bitfinex.com/reference#rest-auth-calc-order-avail
    def available_currency(currency)
      res = request("auth/calc/order/avail", {
        symbol: currency,
        dir: 1,
        type: "FUNDING",
      }).body
      res = JSON.parse(res)
      return res[0].abs
    end

    # 收入列表
    # Ratelimit: 15 req/min
    # https://docs.bitfinex.com/v1/reference#rest-auth-balance-history
    def interest_history(currency, start_time, end_time)
      res = v1_request("history", {
        currency: currency,
      # wallet: "deposit",
      # since: "1570272762.0",
      # until: "1572951124.0",
      # limit: 500,
      })
      res = JSON.parse(res)
      return res
    end
  end
end
